local hcTk = HCToolkit

function hcTk.CreateKilJaedenSmallSoaksPanel(container)
    hcTk.AssignmentCreateHeader(container, "Kil'Jaeden Small Armageddons")
    local markers = { [1] = "Star", [2] = "Circle", [3] = "Square", [4] = "Cross" }
    for k, v in ipairs(markers) do
        for i = 1, 4 do
            container:AddChild(hcTk.AssignmentCreateEditBox(hcTk.GetSmallSoakAssignment(v, i), v .. " #" .. i, function(e) hcTk.SetSmallSoakAssignment(v, i, e:GetText()) end))
        end
    end
end

function hcTk.CreateKilJaedenBigSoaksPanel(container)
    hcTk.AssignmentCreateHeader(container, "Kil'Jaeden Big Armageddons")
    for i = 1, 11 do
        for j = 1, 2 do
            container:AddChild(hcTk.AssignmentCreateEditBox(hcTk.GetBigSoakAssignment(i, j), "Soak " .. i .. " #" .. j, function(e) hcTk.SetBigSoakAssignment(i, j, e:GetText()) end))
        end
    end
end

function hcTk.GetSmallSoakAssignment(marker, number)
    return hcTk.DB.profile.Assignments.TOS.KilJaedenArmageddonSmallSoaks[marker][number]
end

function hcTk.SetSmallSoakAssignment(marker, number, text)
    hcTk.DB.profile.Assignments.TOS.KilJaedenArmageddonSmallSoaks[marker][number] = text
end

function hcTk.GetBigSoakAssignment(soak, number)
    return hcTk.DB.profile.Assignments.TOS.KilJaedenArmageddonBigSoaks[soak][number]
end

function hcTk.SetBigSoakAssignment(soak, number, text)
    hcTk.DB.profile.Assignments.TOS.KilJaedenArmageddonBigSoaks[soak][number] = text
end