local hcTk = HCToolkit

function hcTk.KilJaedenEncounterStart()
    hcTk.Encounter["SmallArmageddonEnabled"] = false
    hcTk.Encounter["BigArmageddonEnabled"] = false
    hcTk.Encounter["SmallArmageddonGroups"] = { ["Star"] = {}, ["Circle"] = {}, ["Square"] = {}, ["Cross"] = {}, }
    hcTk.Encounter["BigArmageddonGroups"] = { [1] = {}, [2] = {}, [3] = {}, [4] = {}, [5] = {}, [6] = {}, [7] = {}, [8] = {}, [9] = {}, [10] = {}, [11] = {}, }
    hcTk.Encounter["NextArmageddon"] = 0
    hcTk.Encounter["Phase"] = 1
    for k, v in pairs(hcTk.Group) do
        v["SmallArmageddonDot"] = false
    end

    C_Timer.After(0.5, hcTk.KilJaedenSendSmallArmageddonGroups)
    C_Timer.After(0.5, hcTk.KilJaedenSendBigArmageddonGroups)
end

function hcTk.KilJaedenEncounterEnd()
    hcTk.Encounter["SmallArmageddonEnabled"] = nil
    hcTk.Encounter["BigArmageddonEnabled"] = nil
    hcTk.Encounter["SmallArmageddonGroups"] = nil
    hcTk.Encounter["BigArmageddonGroups"] = nil
    hcTk.Encounter["NextArmageddon"] = nil
    hcTk.Encounter["Phase"] = nil
    for k, v in pairs(hcTk.Group) do
        v["SmallArmageddonDot"] = nil
    end
end

function hcTk.KilJaedenCombatLog(...)
    local msg = select(2, ...)
    if (hcTk.KilJaedenCombatLogFns[msg] ~= nil) then
        hcTk.KilJaedenCombatLogFns[msg](...)
    end
end

function hcTk.KilJaedenSpellAuraApplied(...)
    local destGUID, _, _, _, spellId = select(8, ...)
    if (hcTk.Group[destGUID] ~= nil and spellId == 234310) then -- Armageddon Rain
        hcTk.Group[destGUID]["SmallArmageddonDot"] = true
        hcTk.KilJaedenSmallArmageddonAlert()
    end
end

function hcTk.KilJaedenSpellAuraAppliedDose(...)

end

function hcTk.KilJaedenSpellAuraRemoved(...)
    local destGUID, _, _, _, spellId = select(8, ...)
    if (hcTk.Group[destGUID] ~= nil and spellId == 234310) then -- Armageddon Rain
        hcTk.Group[destGUID]["SmallArmageddonDot"] = false
        hcTk.KilJaedenSmallArmageddonAlert()
    end
end

function hcTk.KilJaedenSpellCastSuccess(...)
    local destGUID, _, _, _, spellId = select(8, ...)
    if (spellId == 240910) then -- Armageddon
        hcTk.KilJaedenArmageddonNotify()
        C_Timer.After(3, hcTk.KilJaedenArmageddonNotify)
        C_Timer.After(6, hcTk.KilJaedenArmageddonNotify)
        C_Timer.After(9, hcTk.KilJaedenBigArmageddonAlert)
    elseif (spellId == 241983) then -- Deceiver's Veil
        hcTk.Encounter["Phase"] = 2.5
        hcTk.Encounter["SmallArmageddonEnabled"] = false
        hcTk.Encounter["BigArmageddonEnabled"] = false
        hcTk.FrameUpdateText(HCToolkitGroupFrame, "")
        hcTk.FrameUpdateText(HCToolkitPersonalFrame, "")
    elseif (spellId == 238999 and hcTk.Encounter["Phase"] ~= 3) then -- Darkness Of A Thousand Souls
        -- Maybe dip in warning
        hcTk.Encounter["Phase"] = 3
    end
end

function hcTk.KilJaedenUnitDied(...)
    local destGUID = select(8, ...)
    if (hcTk.Group[destGUID] ~= nil) then
        hcTk.Group[destGUID]["SmallArmageddonDot"] = false
        hcTk.KilJaedenSmallArmageddonAlert()
    end
end

function hcTk.KilJaedenSmallArmageddonAlert()
    if (hcTk.GenericGetBossOption("TOS", "KilJaeden", "ArmageddonSmallSoaks") and hcTk.Encounter["SmallArmageddonEnabled"]) then
        local alert = ""
        alert = hcTk.KilJaedenSmallArmageddonBuildGroup(hcTk.Encounter["SmallArmageddonGroups"]["Star"], 1)
        alert = alert .. hcTk.KilJaedenSmallArmageddonBuildGroup(hcTk.Encounter["SmallArmageddonGroups"]["Circle"], 2)
        alert = alert .. hcTk.KilJaedenSmallArmageddonBuildGroup(hcTk.Encounter["SmallArmageddonGroups"]["Square"], 6)
        alert = alert .. hcTk.KilJaedenSmallArmageddonBuildGroup(hcTk.Encounter["SmallArmageddonGroups"]["Cross"], 7)
        hcTk.FrameUpdateText(HCToolkitGroupFrame, alert:sub(1, -2))
    end

end

function hcTk.KilJaedenSmallArmageddonBuildGroup(group, marker)
    local available = 0
    local total = 0
    for k, guid in ipairs(group) do
        if (hcTk.Group[guid] ~= nil and hcTk.Group[guid]["alive"]) then
            if (not hcTk.Group[guid]["SmallArmageddonDot"]) then
                available = available + 1
            end
            
            total = total + 1
        end
    end

    return string.format("%s: %d/%d\n", hcTk.MarkerIdToString(marker), available, total)
end

function hcTk.KilJaedenBigArmageddonAlert()
    if (hcTk.Encounter["NextArmageddon"] ~= nil) then
        hcTk.Encounter["NextArmageddon"] = hcTk.Encounter["NextArmageddon"] + 1
    end
    if (hcTk.GenericGetBossOption("TOS", "KilJaeden", "ArmageddonBigSoaks") and hcTk.Encounter["BigArmageddonEnabled"] and hcTk.Encounter["BigArmageddonGroups"] ~= nil and hcTk.Encounter["BigArmageddonGroups"][hcTk.Encounter["NextArmageddon"]] ~= nil) then
        local player1 = hcTk.KilJaedenBigArmageddonGetPlayer(hcTk.Encounter["BigArmageddonGroups"][hcTk.Encounter["NextArmageddon"]][1])
        local player2 = hcTk.KilJaedenBigArmageddonGetPlayer(hcTk.Encounter["BigArmageddonGroups"][hcTk.Encounter["NextArmageddon"]][2])
        hcTk.FrameUpdateText(HCToolkitPersonalFrame, string.format("%d: %s and %s", hcTk.Encounter["NextArmageddon"], player1, player2))
    end
end

function hcTk.KilJaedenBigArmageddonGetPlayer(guid)
    if (hcTk.Group[guid] ~= nil) then
        return hcTk.UnitPlayerString(hcTk.Group[guid])
    else
        return "Tank"
    end
end

function hcTk.KilJaedenArmageddonNotify()
    if (hcTk.GenericGetBossOption("TOS", "KilJaeden", "ArmageddonNotify") and hcTk.Group[hcTk.PlayerGUID] ~= nil and hcTk.Group[hcTk.PlayerGUID]["SmallArmageddonDot"]) then
        SendChatMessage("Dot!", "SAY")
    end
end

function hcTk.KilJaedenReceiveSmallArmageddonGroups(data)
    hcTk.Encounter["SmallArmageddonGroups"]["Star"] = data["Star"]
    hcTk.Encounter["SmallArmageddonGroups"]["Circle"] = data["Circle"]
    hcTk.Encounter["SmallArmageddonGroups"]["Square"] = data["Square"]
    hcTk.Encounter["SmallArmageddonGroups"]["Cross"] = data["Cross"]

    hcTk.Encounter["SmallArmageddonEnabled"] = true

    if (hcTk.GenericGetBossOption("TOS", "KilJaeden", "ArmageddonSmallSoaks")) then
        hcTk.KilJaedenSmallArmageddonAlert()
    end
end

function hcTk.KilJaedenReceiveBigArmageddonGroups(data)
    for i = 1, 11 do
        hcTk.Encounter["BigArmageddonGroups"][i] = data[i]
    end

    hcTk.Encounter["BigArmageddonEnabled"] = true
    
    if (hcTk.GenericGetBossOption("TOS", "KilJaeden", "ArmageddonBigSoaks")) then
        hcTk.KilJaedenBigArmageddonAlert()
    end
end

function hcTk.KilJaedenSendSmallArmageddonGroups()
    if (UnitIsGroupLeader(hcTk.Group[hcTk.PlayerGUID]["unit"])) then
        local data = {
            ["Star"] = hcTk.GroupNameToGUIDs(hcTk.DB.profile.Assignments.TOS.KilJaedenArmageddonSmallSoaks["Star"]),
            ["Circle"] = hcTk.GroupNameToGUIDs(hcTk.DB.profile.Assignments.TOS.KilJaedenArmageddonSmallSoaks["Circle"]),
            ["Square"] = hcTk.GroupNameToGUIDs(hcTk.DB.profile.Assignments.TOS.KilJaedenArmageddonSmallSoaks["Square"]),
            ["Cross"] = hcTk.GroupNameToGUIDs(hcTk.DB.profile.Assignments.TOS.KilJaedenArmageddonSmallSoaks["Cross"]),
            ["type"] = "KilJaedenSendSmallArmageddonGroups",
        }

        if (#data["Star"] > 0 or #data["Circle"] > 0 or #data["Square"] > 0 or #data["Cross"] > 0) then
            hcTk.DebugPrint("Sending Small Armageddon Soak Groups")
            hcTk:SendCommMessage("HCToolkitBoss", hcTk:Serialize(data), "RAID")
        end
    end
end

function hcTk.KilJaedenSendBigArmageddonGroups()
    if (UnitIsGroupLeader(hcTk.Group[hcTk.PlayerGUID]["unit"])) then
        local data = {}
        for k, v in ipairs(hcTk.DB.profile.Assignments.TOS.KilJaedenArmageddonBigSoaks) do
            data[k] = hcTk.GroupNameToGUIDs(v)
        end
        data["type"] = "KilJaedenSendBigArmageddonGroups"

        hcTk.DebugPrint("Sending Big Armageddon Soak Groups")
        hcTk:SendCommMessage("HCToolkitBoss", hcTk:Serialize(data), "RAID")
    end
end

hcTk.KilJaedenCombatLogFns = {
    ["SPELL_AURA_APPLIED"] = hcTk.KilJaedenSpellAuraApplied,
    ["SPELL_AURA_APPLIED_DOSE"] = hcTk.KilJaedenSpellAuraAppliedDose,
    ["SPELL_AURA_REMOVED"] = hcTk.KilJaedenSpellAuraRemoved,
    ["SPELL_CAST_SUCCESS"] = hcTk.KilJaedenSpellCastSuccess,
    ["UNIT_DIED"] = hcTk.KilJaedenUnitDied
}